Enquete/Enquete/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('main.urls')),
    path('admin/', admin.site.urls),
]

Enquete/main/urls.py
from django.urls import path
from . import views
app_name = 'main'
urlpatterns = [
    path('',views.IndexView.as_view(), name='index'),

    path('enquete/<int:pk>', views.DetalhesView.as_view(), name='detalhes'),

    path('enquete/<int:pk>/resultado', views.ResultadoView.as_view(), name='resultado'),

    path('enquete/<int:id_enquete>/votacao', views.Votacao, name='votacao'),

    path('enquete/<int:pk>/comentario', views.ComentarioView.as_view(), name='comentario'),


    ]

Enquete/main/models.py
from django.db import models
from django.utils import timezone
import datetime

class Pergunta(models.Model):
    texto = models.CharField(max_length = 200)
    data_publicacao = models.DateTimeField('Data de publicação')
    def __str__(self):
        return self.texto
    def publicada_recentemente(self):
        agora = timezone.now()
        return agora-datetime.timedelta(days=1) <= self.data_publicacao <= agora

class Opcao(models.Model):
    texto = models.CharField(max_length = 200)
    votos = models.IntegerField(default = 0)
    pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    def __str__(self):
        return self.texto

class Comentario(models.Model):
    texto = models.CharField(max_length = 200)
    nome_autor = models.CharField(max_length = 200)
    data_insercao = models.DateTimeField('Data de inserção')
    pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    def __str__(self):
            return self.texto

Enquete/main/views.py
from django.shortcuts import render, get_object_or_404
from django.http import   HttpResponseRedirect
from django.urls import reverse
from django.views import generic
from django.utils import timezone
from .models import Pergunta, Opcao, Comentario


class IndexView(generic.ListView):
    template_name = 'main/index.html'
    context_object_name = 'ultimas_perguntas'
    def get_queryset(self):
        return  Pergunta.objects.filter(
            data_publicacao__lte=timezone.now()
            ).order_by('-data_publicacao')[:5]


class DetalhesView(generic.DetailView):
    model = Pergunta
    template_name = 'main/detalhes.html'


class ResultadoView(generic.DetailView):
    model = Pergunta
    template_name = 'main/resultado.html'

class ComentarioView(generic.DetailView):
    model = Comentario
    template_name = 'main/comentario.html'



def Votacao(request, id_enquete):
     pergunta = get_object_or_404(Pergunta, pk=id_enquete)
     try:
        opcao_selecionada = pergunta.opcao_set.get(pk=request.POST['opcao'])
     except (KeyError, Opcao.DoesNotExist):
            return render(request,'main/detalhes.html', {
             'pergunta': pergunta,
             'error_message': "Selecione uma opção válida!"
         })
     else:
            opcao_selecionada.votos += 1
            opcao_selecionada.save()
            return HttpResponseRedirect(
                reverse('main:resultado', args=(pergunta.id,))
                )

Enquete/main/templates/main/comentario.html
<html>
    <head>
        <title> App Enquete - Detalhes do comentario </title>
    </head>
    <body>
       <h1>Detalhes do comentario da pergunta:{{pergunta.id}}</h1>

        <u>Comentário:</u>  {{comentario.texto}}<br/>
        <u>Autor:</u>  {{comentario.nome_autor}}<br/>
        <u>Data de comentario:</u>  {{comentario.data_insercao}}<br/>
        <hr/>

         <a href="{% url 'main:index' %}">Deseja retornar para a página principal?</a>


    </body>
</html>

Enquete/main/templates/main/detalhes.html
<html>
    <head>
        <title>App enquete - detalhes</title>
    </head>
    <body>
        <h1>Detalhes da Enquete {{ pergunta.id }}</h1>
        <u>Pergunta</u>: {{pergunta.texto}}<br/>
        <u>Data de Publicação</u>: {{pergunta.data_publicacao}}
        {% if error_message %}
        <hr>
        <strong>{{ error_message}}</strong>
        <hr/>
        {% endif %}
        <form action="{% url 'main:votacao' pergunta.id %}" method="post">
             {% csrf_token %}
        <ul>
            {% for opcao in pergunta.opcao_set.all %}
                <li><input type="radio" name="opcao"
                id="opcao{{ forloop.counter}}" value="{{ opcao.id }}">
                <label for="opcao{{ forloop.counter }}">{{ opcao.texto }}
                </label>
            </li>
            {% endfor %}
        </ul>
        <input type="submit" value="Registre o seu voto">
      </form>

        <ul>
            <h3> Comentários referentes a pergunta {{pergunta.id}}</h3>
                 {% for comentario in pergunta.comentario_set.all %}
                    <li><a href="{% url 'main:comentario' comentario.id %}">{{ comentario.texto }}</a> </li>
                 {% endfor %}
        </ul>
            <a href="{% url 'main:index' %}">Deseja retornar para a página principal?</a>
    </body>
</html>

Enquete/main/templates/main/pergunta_list.html
<html>
    <head>
        <title>App enquete - Alexia Tuane</title>
    </head>
    <body>
        {% if ultimas_perguntas %}
             <h2> Lista das últimas enquetes</h2>
             <ul>
                 {% for pergunta in ultimas_perguntas %}
                        <li>
                            <a href="{% url 'main:detalhes' pergunta.id %}">
                                {{pergunta.texto}}

                        </a></li>
                  {% endfor %}
             </ul>
        {% else %}
             <h2> Não há enquetes cadastradas até o momento</h2>
        {% endif %}
    </body>
</html>

Enquete/main/templates/main/resultado.html
<html>
    <head>
        <title> App Enquete - Resultado</title>
    </head>
    <body>
        <h2>Resultado Parcial da enquete {{ pergunta.id }}</h2>
         <u>Pergunta</u>: {{pergunta.texto}}<br/>
        <u>Data de Publicação</u>: {{pergunta.data_publicacao}}
        <ul>
            {% for opcao in pergunta.opcao_set.all %}
                <li>{{ opcao.texto }} = {{opcao.votos}}
                voto{{ opcao.votos | pluralize }}</li>
            {% endfor %}
        </ul>
        <hr/>
        <a href="{% url 'main:detalhes' pergunta.id %}">Deseja votar novamente?!</a><br>
         <a href="{% url 'main:index' %}">Deseja retornar para a página principal?</a>
    </body>
</html>